OSMIUM-CHECK-REFS(1)

NAME
osmium-check-refs - check referential integrity of OSM file

SYNOPSIS
osmium check-refs [OPTIONS] OSM-DATA-FILE

DESCRIPTION
Ways in OSM files refer to OSM nodes; relations refer to nodes, ways, or other relations. This command checks whether all objects referenced in the input file are also present in the input file.

Referential integrity is often broken in extracts. This can lead to problems with some uses of the OSM data. Use this command to make sure your data is good.

If the option --check-relations/-r is not given, this command will only check if all nodes referenced in ways are in the file, with the option, relations will also be checked.

This command expects the input file to be ordered in the usual way: First nodes in order of ID, then ways in order of ID, then relations in order of ID. Negative IDs are allowed, they must be ordered before the positive IDs. See the osmium-sort(1) man page for details of the ordering.

This command will only work for OSM data files, not OSM history files or change files.

This commands reads its input file only once, ie. it can read from STDIN.

OPTIONS

-i, --show-ids
    Print all missing IDs to STDOUT. If you don’t specify this option, only a summary is shown.

-r, --check-relations
    Also check referential integrity of relations. Without this option, only nodes in ways are checked.

COMMON OPTIONS

-h, --help
    Show usage help.

-v, --verbose
    Set verbose mode. The program will output information about what it is doing to STDERR.

--progress
    Show progress bar. Usually a progress bar is only displayed if STDOUT and STDERR are detected to be TTY. With this option a progress bar is always shown. Note that a progress bar will never be shown when reading from STDIN or a pipe.

--no-progress
    Do not show progress bar. Usually a progress bar is displayed if STDOUT and STDERR are detected to be a TTY. With this option the progress bar is suppressed. Note that a progress bar will never be shown when reading from STDIN or a pipe.

INPUT OPTIONS

-F, --input-format=FORMAT
    The format of the input file(s). Can be used to set the input format if it can’t be autodetected from the file name(s). This will set the format for all input files, there is no way to set the format for some input files only. See osmium-file-formats(5) or the libosmium manual for details.

MEMORY USAGE
osmium check-refs will do the check in one pass through the input data. It needs enough main memory to store all temporary data.

Largest memory need will be about 1 bit for each node ID, that’s roughly 860 MB these days (February 2020). With the --check-relations/-r option memory use will be a bit bigger.

DIAGNOSTICS
osmium check-refs exits with exit code

0   if all references are satisfied

1   if there was an error processing the data or some references were not satisfied, or

2   if there was a problem with the command line arguments.

SEE ALSO

•   osmium(1), osmium-file-formats(5), osmium-sort(1)

•   Osmium website (https://osmcode.org/osmium-tool/)

COPYRIGHT

Copyright (C) 2013-2026 Jochen Topf <jochen@topf.org>.

License GPLv3+: GNU GPL version 3 or later <https://gnu.org/licenses/gpl.html>. This is free software: you are free to change and redistribute it. There is NO WARRANTY, to the extent permitted by law.

CONTACT

If you have any questions or want to report a bug, please go to https://osmcode.org/contact.html

AUTHORS
Jochen Topf <jochen@topf.org>.